var Image0
var width,height,channels
var pixel_cal,pixel_size
var Cellperimeter,Cellferet,Cellarea, cellcount
var gdensity,gsynapsecount,greensumper,greensumar
var bdensity,bsynapsecount,bluepersum,bluesumar

//Clear existing data
run("Clear Results");
run("Set Measurements...","redirect=None decimal=3");
		if (isOpen("Summary") == true) {
		selectWindow("Summary");
		run("Close");
		}

//Defines active image
path=getDirectory("image");
filename=getFileList(path);
Image0=getTitle;
selectWindow(Image0);


//User input regarding: ((pixel calibration)) ((synapse inclusion area)) ((channel identities))

	Dialog.create("Welcome to ImmunoQuant");
	Dialog.addNumber("Enter the width of the image in microns",129.14);
	Dialog.addNumber("Enter the maximum soma to synapse distance to be included (microns)",2);
	Dialog.addMessage("________________________________________________________________________________");
	Dialog.addMessage("Define given channels");
	Dialog.addString("What signal type does the green signal represent?","GAD67");
	Dialog.addString("What signal type does the blue signal represent?","GlyT2");
	Dialog.addMessage("________________________________________________________________________________");
	Dialog.show();

//Defines parameters as input by the user
		pixel_cal = Dialog.getNumber();
		coincdist = Dialog.getNumber();
		greenname = Dialog.getString();
		bluename = Dialog.getString();
		selectWindow(Image0);
		frame_width=getWidth();
		frame_height=getHeight();
		pixel_size = ((pixel_cal) / (frame_width));
		run("Set Scale...", "distance=1 known=pixel_size pixel=1 unit=um");
		useablecoincdist = coincdist + 2 ; 
		
Spot_Detector();



///////Processes the image according to user specification\\\\\\\\

function Spot_Detector(){

roi_count = roiManager("count");
if (roi_count>0){
	roiManager("Delete");	}

//Defines the active image for coordination of split channels
rename("Image");
selectWindow("Image");
run("Split Channels");
selectWindow("Image (blue)");
threshold();
selectWindow("Image (green)");
threshold();
if (isOpen("Threshold") == true) {
				selectWindow("Threshold");
				run("Close");
			}	

//User manually designates somata of interest

selectWindow("Image (red)");
setTool("freehand");
waitForUser("Please use the freehand tool to trace each soma of interest, \nthen add it to the ROI manager by pressing <t> \nPress OK to proceed.");

		
//Define necessary arrays based on number of drawn cells
		
		cellcount=roiManager("count");
		Cellferet=newArray(cellcount);
		Cellperimeter=newArray(cellcount);
		Cellarea=newArray(cellcount);
		cellxo=newArray(cellcount);
		cellx=newArray(cellcount);
		cellyo=newArray(cellcount);
		celly=newArray(cellcount);
		Cellperimeter=newArray(cellcount);
		gdensity=newArray(cellcount);
		bdensity=newArray(cellcount);
		Cellarea=newArray(cellcount);
		Cellferet=newArray(cellcount);
		gsynapsecount=newArray(cellcount);
		gboutondensity=newArray(cellcount);
		greensumper=newArray(cellcount);
		greensumar=newArray(cellcount);
		bsynapsecount=newArray(cellcount);
		bluepersum=newArray(cellcount);
		bluesumar=newArray(cellcount);
		bboutondensity=newArray(cellcount);

//Gathers somata characteristics as defined by the user
for (k=0; k<cellcount; k++) {
			roiManager("Select",k);
			run("Set Measurements...", "perimeter centroid area feret's redirect=None decimal=3");
			run("Measure");
			selectWindow("Results");
			lines = split(getInfo(), "\n");
			headings = split(lines[0], "\t");
			values = split(lines[1], "\t");
				for (i=5; i<6; i++){
					Cellferet[k]= values[i];
					}
				for (i=1; i<2; i++){
					Cellarea[k]= values[i];
					}	
				for (i=4; i<5; i++){
					Cellperimeter[k]= values[i];
					}
				for (i=2; i<3; i++){
					cellxo[k]=values[i];
					cellx[k]=parseInt(cellxo[k]);
				}
				for (i=3;i<4;i++){
					cellyo[k]=values[i];
					celly[k]=parseInt(cellyo[k]);
				}
		selectWindow("Results");
		run("Close");		
		}


//Modify cell ROIs into "donut formation"
selectWindow("Image (red)");

	for (i=0;i<cellcount;i++){
		roiManager("Select",i);
		run("Enlarge...", "enlarge=-1");
		roiManager("Add");
		roiManager("Select",i);
		run("Enlarge...", "enlarge=2");
		roiManager("Add");
		for (j=cellcount+3*i;j<cellcount+3*i+1;j++){
			S=parseInt(j);
		}
		for (j=cellcount+3*i+1;j<cellcount+3*i+2;j++){
			L=parseInt(j);
		}
		roiManager("Select",newArray(L,S));
		roiManager("XOR");
		roiManager("Add");
		roiManager("Update");
}

//Detect boutons in each channel for each cell

for (v=0; v<cellcount; v++) {

	
//for channel 1
	selectWindow("Image (green)");
	roiManager("Select",v*3+cellcount+2);
	run("Set Measurements...", "feret's redirect=None decimal=3");
	run("Analyze Particles...", "display");
		gsynapsecount[v]=nResults;
		greensumper[v] = 0; 
		greensumar[v] = 0;
		centdistgsum = 0;
		gdensity[v] = 0;
		gx=0;
		gy=0;
		selectWindow("Results"); 
		lines1 = split(getInfo(), "\n"); 
		headings = split(lines1[0], "\t"); 
			for (j=1; j<lines1.length; j++) { 
        		values = split(lines1[j], "\t"); 
        		gper = values[1]; 
        		greensumper[v] = greensumper[v] + gper; 
				}

				 
gdensity[v] = (greensumper[v]/(Cellperimeter[v]));
gboutondensity[v] = (gsynapsecount[v]/Cellperimeter[v]);
run("Clear Results");

//Area data for channel 1
run("Set Measurements...", "area redirect=None decimal=3");
		run("Analyze Particles...", "display");
		selectWindow("Results"); 
		lines1 = split(getInfo(), "\n"); 
		headings = split(lines1[0], "\t"); 
			for (j=1; j<lines1.length; j++) { 
        	values = split(lines1[j], "\t"); 
        	gar = values[1]; 
        	greensumar[v] = greensumar[v] + gar; 
			}
		
run("Clear Results");


//For Channel 2
selectWindow("Image (blue)");
roiManager("Select",v*3+cellcount+2);
run("Set Measurements...", "feret's redirect=None decimal=3");
run("Analyze Particles...", "display");
	bsynapsecount[v] = nResults;
	bluepersum[v] = 0;
	bdensity[v] = 0; 
	bluesumar[v] = 0;
	centdistbsum = 0;
	bx=0;
	by=0;
selectWindow("Results"); 
lines1 = split(getInfo(), "\n"); 
headings = split(lines1[0], "\t"); 
	for (j=1; j<lines1.length; j++) { 
        	values = split(lines1[j], "\t"); 
        	b = values[1]; 
        	bluepersum[v] = bluepersum[v] + b; 
			} 	
bdensity[v] = (bluepersum[v]/(Cellperimeter[v]));
bboutondensity[v] = (bsynapsecount[v]/Cellperimeter[v]);
run("Clear Results");

//Area data for channel 2
run("Set Measurements...", "area redirect=None decimal=3");
		run("Analyze Particles...", "display");
		selectWindow("Results"); 
		lines1 = split(getInfo(), "\n"); 
		headings = split(lines1[0], "\t"); 
			for (j=1; j<lines1.length; j++) { 
        	values = split(lines1[j], "\t"); 
        	bar = values[1]; 
        	bluesumar[v] = bluesumar[v] + bar; 
			}
run("Clear Results");
selectWindow("Results");
run("Close");
}

//Produces result spreadsheet
for (q=0;q<cellcount;q++){
		setResult("Soma Perimeter", q, Cellperimeter[q]);
		setResult("GABA Coverage", q, gdensity[q]);
		setResult("Glycine Coverage",q,bdensity[q]);
		setResult("Soma Area",q, Cellarea[q]);
		setResult("Soma Feret's Diameter",q, Cellferet[q]);
		setResult("GAD67 Bouton Count",q,gsynapsecount[q]);
		setResult("GAD67 Bouton Density",q,gboutondensity[q]);
		setResult("GAD67 Abuttal",q, greensumper[q]);
		setResult("GAD67 Area Sum",q,greensumar[q]);
		setResult("GlyT2 Bouton Count",q,bsynapsecount[q]);
		setResult("GlyT2 Bouton Density",q,bboutondensity[q]);
		setResult("GlyT2 Abuttal",q, bluepersum[q]);
		setResult("GlyT2 Area Sum",q,bluesumar[q]);
}
updateResults();
run("Close All");
roiManager("Delete");
selectWindow("ROI Manager");
run("Close");
}


//////////////////////////////////// RENYI ENTROPY THRESHOLD\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
function threshold(){
	setAutoThreshold("RenyiEntropy dark");
	setOption("BlackBackground", false);
	run("Convert to Mask");
	run("Watershed");
}